Loading...
Searching...
No Matches
pcl::BearingAngleImage Class Reference

class BearingAngleImage is used as an interface to generate Bearing Angle(BA) image. More...

`#include <pcl/range_image/bearing_angle_image.h>`

Inheritance diagram for pcl::BearingAngleImage:

## Public Types

using | BaseClass = pcl::PointCloud< PointXYZRGBA >
Public Types inherited from pcl::PointCloud< PointXYZRGBA >
using | PointType = PointXYZRGBA
using | VectorType = std::vector< PointXYZRGBA, Eigen::aligned_allocator< PointXYZRGBA > >
using | CloudVectorType = std::vector< PointCloud< PointXYZRGBA >, Eigen::aligned_allocator< PointCloud< PointXYZRGBA > > >
using | Ptr = shared_ptr< PointCloud< PointXYZRGBA > >
using | ConstPtr = shared_ptr< const PointCloud< PointXYZRGBA > >
using | value_type = PointXYZRGBA
using | reference = PointXYZRGBA &
using | const_reference = const PointXYZRGBA &
using | difference_type = typename VectorType::difference_type
using | size_type = typename VectorType::size_type
using | iterator = typename VectorType::iterator
using | const_iterator = typename VectorType::const_iterator
using | reverse_iterator = typename VectorType::reverse_iterator
using | const_reverse_iterator = typename VectorType::const_reverse_iterator

## Public Member Functions

| BearingAngleImage ()
| Constructor.
void | reset ()
| Reset all values to an empty Bearing Angle image.
double | getAngle (const PointXYZ &point1, const PointXYZ &point2)
| Calculate the angle between the laser beam and the segment joining two consecutive measurement points.
void | generateBAImage (PointCloud< PointXYZ > &point_cloud)
| Transform 3D point cloud into a 2D Bearing Angle(BA) image.
Public Member Functions inherited from pcl::PointCloud< PointXYZRGBA >
| PointCloud ()=default
| Default constructor.
| PointCloud (const PointCloud< PointXYZRGBA > &pc, const Indices &indices)
| Copy constructor from point cloud subset.
| PointCloud (std::uint32_t width_, std::uint32_t height_, const PointXYZRGBA &value_=PointXYZRGBA())
| Allocate constructor from point cloud subset.
PointCloud & | operator+= (const PointCloud &rhs)
| Add a point cloud to the current cloud.
PointCloud | operator+ (const PointCloud &rhs)
| Add a point cloud to another cloud.
const PointXYZRGBA & | at (int column, int row) const
| Obtain the point given by the (column, row) coordinates.
PointXYZRGBA & | at (int column, int row)
| Obtain the point given by the (column, row) coordinates.
const PointXYZRGBA & | at (std::size_t n) const
PointXYZRGBA & | at (std::size_t n)
const PointXYZRGBA & | operator() (std::size_t column, std::size_t row) const
| Obtain the point given by the (column, row) coordinates.
PointXYZRGBA & | operator() (std::size_t column, std::size_t row)
| Obtain the point given by the (column, row) coordinates.
bool | isOrganized () const
| Return whether a dataset is organized (e.g., arranged in a structured grid).
Eigen::Map< Eigen::MatrixXf, Eigen::Aligned, Eigen::OuterStride<> > | getMatrixXfMap (int dim, int stride, int offset)
| Return an Eigen MatrixXf (assumes float values) mapped to the specified dimensions of the PointCloud.
const Eigen::Map< const Eigen::MatrixXf, Eigen::Aligned, Eigen::OuterStride<> > | getMatrixXfMap (int dim, int stride, int offset) const
| Return an Eigen MatrixXf (assumes float values) mapped to the specified dimensions of the PointCloud.
Eigen::Map< Eigen::MatrixXf, Eigen::Aligned, Eigen::OuterStride<> > | getMatrixXfMap ()
const Eigen::Map< const Eigen::MatrixXf, Eigen::Aligned, Eigen::OuterStride<> > | getMatrixXfMap () const
iterator | begin () noexcept
const_iterator | begin () const noexcept
iterator | end () noexcept
const_iterator | end () const noexcept
const_iterator | cbegin () const noexcept
const_iterator | cend () const noexcept
reverse_iterator | rbegin () noexcept
const_reverse_iterator | rbegin () const noexcept
reverse_iterator | rend () noexcept
const_reverse_iterator | rend () const noexcept
const_reverse_iterator | crbegin () const noexcept
const_reverse_iterator | crend () const noexcept
std::size_t | size () const
index_t | max_size () const noexcept
void | reserve (std::size_t n)
bool | empty () const
PointXYZRGBA * | data () noexcept
const PointXYZRGBA * | data () const noexcept
void | resize (std::size_t count)
| Resizes the container to contain `count` elements.
void | resize (uindex_t new_width, uindex_t new_height)
| Resizes the container to contain `new_width * new_height` elements.
void | resize (index_t count, const PointXYZRGBA &value)
| Resizes the container to contain count elements.
void | resize (index_t new_width, index_t new_height, const PointXYZRGBA &value)
| Resizes the container to contain count elements.
const PointXYZRGBA & | operator[] (std::size_t n) const
PointXYZRGBA & | operator[] (std::size_t n)
const PointXYZRGBA & | front () const
PointXYZRGBA & | front ()
const PointXYZRGBA & | back () const
PointXYZRGBA & | back ()
void | assign (index_t count, const PointXYZRGBA &value)
| Replaces the points with `count` copies of `value`
void | assign (index_t new_width, index_t new_height, const PointXYZRGBA &value)
| Replaces the points with `new_width * new_height` copies of `value`
void | assign (InputIterator first, InputIterator last)
| Replaces the points with copies of those in the range `[first, last)`
void | assign (InputIterator first, InputIterator last, index_t new_width)
| Replaces the points with copies of those in the range `[first, last)`
void | assign (std::initializer_list< PointXYZRGBA > ilist)
| Replaces the points with the elements from the initializer list `ilist`
void | assign (std::initializer_list< PointXYZRGBA > ilist, index_t new_width)
| Replaces the points with the elements from the initializer list `ilist`
void | push_back (const PointXYZRGBA &pt)
| Insert a new point in the cloud, at the end of the container.
void | transient_push_back (const PointXYZRGBA &pt)
| Insert a new point in the cloud, at the end of the container.
reference | emplace_back (Args &&...args)
| Emplace a new point in the cloud, at the end of the container.
reference | transient_emplace_back (Args &&...args)
| Emplace a new point in the cloud, at the end of the container.
iterator | insert (iterator position, const PointXYZRGBA &pt)
| Insert a new point in the cloud, given an iterator.
void | insert (iterator position, std::size_t n, const PointXYZRGBA &pt)
| Insert a new point in the cloud N times, given an iterator.
void | insert (iterator position, InputIterator first, InputIterator last)
| Insert a new range of points in the cloud, at a certain position.
iterator | transient_insert (iterator position, const PointXYZRGBA &pt)
| Insert a new point in the cloud, given an iterator.
void | transient_insert (iterator position, std::size_t n, const PointXYZRGBA &pt)
| Insert a new point in the cloud N times, given an iterator.
void | transient_insert (iterator position, InputIterator first, InputIterator last)
| Insert a new range of points in the cloud, at a certain position.
iterator | emplace (iterator position, Args &&...args)
| Emplace a new point in the cloud, given an iterator.
iterator | transient_emplace (iterator position, Args &&...args)
| Emplace a new point in the cloud, given an iterator.
iterator | erase (iterator position)
| Erase a point in the cloud.
iterator | erase (iterator first, iterator last)
| Erase a set of points given by a (first, last) iterator pair.
iterator | transient_erase (iterator position)
| Erase a point in the cloud.
iterator | transient_erase (iterator first, iterator last)
| Erase a set of points given by a (first, last) iterator pair.
void | swap (PointCloud< PointXYZRGBA > &rhs)
| Swap a point cloud with another cloud.
void | clear ()
| Removes all points in a cloud and sets the width and height to 0.
Ptr | makeShared () const
| Copy the cloud to the heap and return a smart pointer Note that deep copy is performed, so avoid using this function on non-empty clouds.

## Protected Attributes

PointXYZRGBA | unobserved_point_
| < This point is used to be able to return a reference to a unknown gray point

## Additional Inherited Members

Static Public Member Functions inherited from pcl::PointCloud< PointXYZRGBA >
static bool | concatenate (pcl::PointCloud< PointXYZRGBA > &cloud1, const pcl::PointCloud< PointXYZRGBA > &cloud2)
static bool | concatenate (const pcl::PointCloud< PointXYZRGBA > &cloud1, const pcl::PointCloud< PointXYZRGBA > &cloud2, pcl::PointCloud< PointXYZRGBA > &cloud_out)
Public Attributes inherited from pcl::PointCloud< PointXYZRGBA >
pcl::PCLHeader | header
| The point cloud header.
std::vector< PointXYZRGBA, Eigen::aligned_allocator< PointXYZRGBA > > | points
| The point data.
std::uint32_t | width
| The point cloud width (if organized as an image-structure).
std::uint32_t | height
| The point cloud height (if organized as an image-structure).
bool | is_dense
| True if no points are invalid (e.g., have NaN or Inf values in any of their floating point fields).
Eigen::Vector4f | sensor_origin_
| Sensor acquisition pose (origin/translation).
Eigen::Quaternionf | sensor_orientation_
| Sensor acquisition pose (rotation).

## Detailed Description

class BearingAngleImage is used as an interface to generate Bearing Angle(BA) image.

Author
  : Qinghua Li (qingh.nosp@m.ua__.nosp@m.li@16.nosp@m.3.co.nosp@m.m)

Definition at line 52 of file bearing_angle_image.h.

## Member Typedef Documentation

## BaseClass

using pcl::BearingAngleImage::BaseClass = pcl::PointCloud<PointXYZRGBA>

Definition at line 56 of file bearing_angle_image.h.

## Constructor & Destructor Documentation

## BearingAngleImage()

pcl::BearingAngleImage::BearingAngleImage | ( |  | ) |

Constructor.

## Member Function Documentation

## generateBAImage()

void pcl::BearingAngleImage::generateBAImage | ( | PointCloud< PointXYZ > & | point_cloud | ) |

Transform 3D point cloud into a 2D Bearing Angle(BA) image.

## getAngle()

double pcl::BearingAngleImage::getAngle | ( | const PointXYZ & | point1,
|  | const PointXYZ & | point2
| ) |  |

Calculate the angle between the laser beam and the segment joining two consecutive measurement points.

Parameters

  point1 |
  point2 |

## reset()

void pcl::BearingAngleImage::reset | ( |  | ) |

Reset all values to an empty Bearing Angle image.

## Member Data Documentation

## unobserved_point_

PointXYZRGBA pcl::BearingAngleImage::unobserved_point_

protected

< This point is used to be able to return a reference to a unknown gray point

Definition at line 81 of file bearing_angle_image.h.

The documentation for this class was generated from the following file:

- pcl/range_image/bearing_angle_image.h